#
#===============================================================================
#
#         FILE:  PQAGlobals.pm
#
#  DESCRIPTION:  global variables
#
#        FILES:  ---
#         BUGS:  ---
#        NOTES:  ---
#       AUTHOR:   (), <>
#      COMPANY:  
#      VERSION:  1.0
#      CREATED:  07/19/08 09:37:38 IST
#     REVISION:  ---
#===============================================================================

use strict;
use warnings;
use LogParser;
use ReportGenerator;
use PQAFunctions;

# boolean constants, its values are not allowable to change., remove it if possible.,
#use constant true => 1;
#use constant false => 0;

# this has to be removed before deploying... 
use lib "/home/sathiyamoorthy/LEARN/PERL/lib/lib/perl/5.8.8/";

# Regular expressions to match the queries and other..
#=====================================================

# to match the statement coming with the keywords LOG or DEBUG.
$PQAGlobals::LOG_OR_DEBUG_LINE = '(LOG|DEBUG):(\s*)(.*)';

# to match the statement coming with the keywords query or statement.
#$PQAGlobals::QUERY_STARTER = '(query|statement):\s*';

# to match the status of the database connection.
$PQAGlobals::STATUS ='(connection|received|unexpected EOF)';

# to match only the duration of the statement in either seconds or milliseconds.
$PQAGlobals::DURATION ='.*duration:([\s\d\.]*)(sec|ms)';

# in postgresql logs, a statement can be printed as a number of lines, so continuation of the 
# first line of the statement will always be starting with may be ( tab - \t or ^I (Ctrl+I=tab) )
# or any whitespace characters.
$PQAGlobals::CONTINUATION_LINE = '^(\^I|\s|\t)';

#$PQAGlobals::CONTEXT_LINE = 'CONTEXT:[\s]*';
#$PQAGlobals::HINT_LINE = 'HINT:\s*';
#$PQAGlobals::DETAIL_LINE = 'DETAIL:\s*';

# to get the error informations, which can be either of WARNING, ERROR, FATAL or PANIC.  
$PQAGlobals::ERROR_LINE = '((WARNING|ERROR|FATAL|PANIC):(\s*)(.*))';

# to match the statement coming with the keywords query or statement.
$PQAGlobals::STATEMENT_LINE = '.*(?:query|STATEMENT):(.*)';

# to match the duration with the statement..
$PQAGlobals::DURATION_WITH_STATEMENT = '.*(?:duration:)([\s\d\.]+)(sec|ms)\s*(?:query|STATEMENT):(.*)';

# to match the pid, which is available in the statement.
$PQAGlobals::MATCH_PID = '\[(\d{1,5})\]';

# if the duration comes after the statement line, then it should be the duration of the
# previous executed query. this global variable is to store the last executed query.
our $previous_query;

# hash to maintain the query details.
our %query_details ;

# hash to maintain the error query details.
our %error_query_details ;

## to get command line options. 
our %options;

# when duration or statement comes with pid, mapping of pid with query and duration
# will be stored in this hash for easy retrieval. once the duration and query
# comes with pid, that will be stored in query_details. 
our %TmpHash;

# variable to store the log file parsed time.
my $LogFileParsedTime;

1;
