#!/usr/bin/perl -s
#===============================================================================
#
#         FILE:  epqa.pl
#
#        USAGE:  ./epqa.pl 
#
#  DESCRIPTION:  This program is to get the options for epqa and
#  open the file and it will do the parsing and it will generate 
#  reports.
#
#      OPTIONS:  ---
# REQUIREMENTS:  ---
#         BUGS:  ---
#        NOTES:  ---
#       AUTHOR:   (), <>
#      COMPANY:  
#      VERSION:  1.0
#      CREATED:  07/21/08 09:08:19 IST
#     REVISION:  ---
#===============================================================================

use strict;
use warnings;

use PQAGlobals;

#my ( $starttime, $endtime );
my $starttime;

# handle the options.
# $t -> -t for text report
# $z -> -z for reading the compressed file
# $n -> -n=10 to tell the number of queries to show
# $f -> -f=<FILENAME> to give the file for parsing the log
use vars qw ( $t $z $f $n );
HandleOptions($t,$z,$f,$n);

# Open the Logfile name given in the command line.
my $LFH=OpenLogFile();

$starttime=time;

# makes the continuous lines as a single line, and calls further functions with that
# line to do the parsing.,
MakeAsOneLine($LFH);

#$endtime=time;

$PQAGlobals::LogFileParsedTime = time - $starttime;

# print html / text report.
PrintOutput();
